#include <gtkutils.h>

void add_menu_item (GtkWidget* filters, char* text, GCallback func) {
    GtkWidget* menuitem = gtk_menu_item_new_with_label (text);
    gtk_menu_append (GTK_MENU (filters), menuitem);
    gtk_signal_connect_object (GTK_OBJECT (menuitem), "activate",
			       GTK_SIGNAL_FUNC (func),
			       GTK_OBJECT (menuitem));
}

void add_left_label_to_table (char* text, GtkWidget* table, int row, int col) {
    GtkWidget* label = gtk_label_new (text);
    gtk_table_attach (GTK_TABLE (table), label, col, col + 1, row, row + 1, 
		      GTK_FILL, 0, 0, 0);
    gtk_label_set_justify (GTK_LABEL (label),  GTK_JUSTIFY_LEFT);
    gtk_misc_set_alignment (GTK_MISC (label), 0, 0.5);
}

GtkWidget* get_table (gchar** labels, tablefunc funcs[], void* v) {
    int i = 0;
    GtkWidget* table = gtk_table_new (1, 2, FALSE);
    gtk_table_set_row_spacings (GTK_TABLE (table), 2);
    gtk_table_set_col_spacings (GTK_TABLE (table), 2);

    while (labels[i] != NULL) {
	add_left_label_to_table (labels[i], table, i, 0);
	add_left_label_to_table (funcs[i](v), table, i, 1);    
	i++;
    } 
    return table;
}

void add_column (GtkWidget* tree, char* label, int pos, 
		 gpointer data, 
		 void (*cb)(GtkWidget*, gpointer), 
		 gint width,  /* set starting width in pixels */
		 int align)   /* 0 = left, 0.5 = center, 1 = right */
{
    GtkCellRenderer *renderer = gtk_cell_renderer_text_new ();
    GtkTreeViewColumn *column = 
	gtk_tree_view_column_new_with_attributes (label, renderer,
						  "text", pos, NULL);
    /* TODO this cant be the right way to set alignment can it? /robo */
    renderer->xalign = align;
    
    gtk_tree_view_append_column (GTK_TREE_VIEW (tree), column);
    gtk_tree_view_column_set_resizable (column, TRUE);
    gtk_tree_view_column_set_sizing (column, GTK_TREE_VIEW_COLUMN_FIXED);
    gtk_tree_view_column_set_min_width (column, width);
    if (cb != NULL)
	g_signal_connect (G_OBJECT (column), "clicked", G_CALLBACK (cb), data);
}

/* Emacs Local Variables: */
/* Emacs mode:C */
/* Emacs c-indentation-style:"gnu" */
/* Emacs c-hanging-braces-alist:((brace-list-open)(brace-entry-open)(defun-open after)(substatement-open after)(block-close . c-snug-do-while)(extern-lang-open after)) */
/* Emacs c-cleanup-list:(brace-else-brace brace-elseif-brace space-before-funcall) */
/* Emacs c-basic-offset:4 */
/* Emacs End: */
